Create or Update Baseline Schedule for Manual Activity Sheet

POST /ws/rest/service/v2/activity/sheet/baseline

Purpose

Creates or updates baseline schedule for a manual activity sheet of a specific Unifier project/shell based on a project_number and activitysheetName as follows:

  • If a baseline schedule does not exist for a manual activity sheet, a baseline schedule is created with the most recent schedule data.
  • If a baseline schedule already exists for a manual activity sheet, it is updated with the most recent schedule data.

    Note:

    Baseline Creation Date is always set to today's date.

Prerequisites

Ensure you have:

  • The required Activity Sheet Services permissions under Activity Manager

    Contact your Company Administrator to set permissions for Activity Sheet Services.

  • Created the Unifier project/shell

Request Format

Send an API request as a JSON Map with the following structure:

{

"options":{"project_number": "<value>",

"activitySheetName" : "<value>"},

"data":["baselineProjectName": "<value>"]

}

Request Parameters - Options Map

Specify the following parameter in the Options JSON map:

Request Parameter Required? Data Type Description
project_number Yes String A valid 'Active' shell number where the baseline schedule is to be created for a manual activity sheet.
activitySheetName Yes String The name of the manual Sheet in the Activity Manager.

Request Parameters - Data Map

Specify the following parameters in Data []:

Request Parameter Required? Data Type Description
baselineProjectName Yes String The baseline project name. It should not match the name of the current manual activity sheet.

Response Format

A JSON object is returned in the following format:

{

"data": [],

"message": [<list of messages>],

"status": <REST status code value>,

"rest_audit_id": <id from the audit table>

}

A successful response displays a status code 200.

A failed response displays a message with a status code.

Sample Success Request

To create a baseline schedule,, send a request in the following format:

{

"options": {

"project_number": "P-0056",

"a ctivitySheetName" : "ManualSheet 01"

},

"data" :[{

"baselineProjectName" : "ManualSheet01 - B1"

}]

}

Sample Success Response

A successful response with status code 200 displays in the following format:

{

"data": [{"baselineProjectName": "ManualSheet01 - B1"}],

"message": ["Baseline is created successfully."],

"status": 200,

rest_audit_id": 12676

}

Sample Failed Request

This is an example of a failed request with an invalid value:

{

"options": {

"project_number": "P-0056",

"activitySheetName" : "ManualSheet01"

},

"data" :[{

"baselineProjectName" : "ManualSheet01 - ABC"

} ]

}

Sample Failed Response

A failed response to create a baseline schedule for a manual activity sheet displays the corresponding status code in the following format:

{

"data": [],

"message": [

"message": "The API request contains an invalid value: [activitySheetName]. Please check if this activitySheetName with type=manual has been configured in Unifier."

],

"status": 12013,

"rest_audit_id": 14302

}

Supported Validation Messages and Status Codes

The following validation messages and status codes display in the response when incorrect values are provided in the request.

Field Name Use-case Scenario Status Code Error Message
project_number project_number is not specified. 12018 The API request is missing the required information: [project_number].
project_number project_number is invalid. 602 Project/Shell Number is not correct.
project_number project_number is inactive. 12020 The API request contains an invalid value: [project_number]. Check the status of this project_number in Unifier.
project_number project_number is empty/blank. 12128 The API request contains empty value for: [project_number].
activitySheetName Activity sheet name is not specified in the request. 12012 The API request is missing the required information: [activitySheetName].
activitySheetName Activity sheet name does not exist. 12013 The API request contains an invalid value: [activitySheetName]. Please check if this activitySheetName with sheet type=manual has been configured in Unifier.
activitySheetName Activity sheet name is not specified in string format 12025 Invalid value was found in a field: [activitySheetName]. Allowed only alphanumeric value.
activitySheetName Activity sheet name value is null or empty. 12068 The API request contains empty value for: [activitySheetName].
baselineProjectName baselineProjectName is not specified in the request. 12801 The API request is missing the required information: [baselineProjectName].
baselineProjectName baselineProjectName value is null or empty. 12802 The API request contains empty value for: [baselineProjectName].
baselineProjectName baselineProjectName exceeds 250 characters. 12803 Invalid value was found in a field: [baselineProjectName]. Allowed length: [250].
baselineProjectName baselineProjectName is not a string. 12804 Invalid value was found in a field: [baselineProjectName]. Allowed only alphanumeric value.
baselineProjectName baselineProjectName matches current activity sheet name. 12805 [baselineProjectName] cannot be same as Current [activitySheetName].
baselineProjectName Multiple baselineProjectName have been specified in the request. 12806 The API request is trying to perform this action for multiple baseline schedules. Allowed to perform this action only for single baseline schedule per request.